<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Controllers</h1>

		<p>Controllers are one of the main parts of a model-view-controller framework.  They determine how a HTTP
		request should be handled.</p>
	</div>

	<div class="content">
		<h1>What is a Controller?</h1>

		<p>A controller in CarbonPHP is just a PHP class that is named so that it can be associated with a URI.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/
		</div>

		<p>The above example shows the controller <b>blog</b> being called, CarbonPHP will attempt to find the
		file <b>blog.php</b> and load it.</p>

		<p>If a controller's name matches the first segment of the URI, the controller will be loaded by CarbonPHP.
		If a controller cannot be found a 404 page is displayed.</p>
	</div>

	<div class="content">
		<h1>Example Controller</h1>

		<p>An easy way to understand controllers is to start by creating your own.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function index()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo 'Hello world!';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>You can then save this file in the <b>application/controllers/</b> folder and visit the site using the URL
		shown below.</p>

		<div class="example">
			www.your-domain.com/index.php/blog/
		</div>

		<p>If you have done everything correctly, the page should be displaying <b>Hello world!</b>.  <i>Note</i>:
		class names must start with an uppercase letter.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class <b>Blog</b> extends Controller<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>The above example is valid, however the example below is invalid.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class <b>blog</b> extends Controller<br />
			&#123;<br />
			<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>You should also always make sure that your controllers <i>extend</i> the parent controller class.  This is
		so that it can inherit the parent's methods.</p>
	</div>

	<div class="content">
		<h1>Methods</h1>

		<p>In the above example we created a method called <b>index()</b>.  The <b>index()</b> method functions just
		like an index.htm page.  It is the default method that is called if no second segment in the URI is specified.
		You can also call the <b>index()</b> method directly.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/<b>index</b>/
		</div>

		<p>As explained previously the second segment of the URI determines which of the controllers methods is called.
		We can try this by adding a second method to our example controller.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function index()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo 'Hello world!';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function post()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo 'More content!';<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>If you now load the follow URL, you can see the output of the new function we added.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/<b>post</b>/
		</div>

		<p>If everything has worked correctly you should see the new message.</p>
	</div>

	<div class="content">
		<h1>Passing URI Segments to Methods</h1>

		<p>If the URI contains more than two segments they can be passed to your methods as function parameters.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>shop</b>/<b>tshirts</b>/<b>short</b>/<b>1</b>
		</div>

		<p>The controller method will be passed the 3rd and 4th URI segments ('short' and '1').</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Shop extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function tshirts($type, $id)<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo $type;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo $id;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;			
		</div>

		<p><i>Note</i>: if you are using the URI routing feature, any segments that are passed to your methods will
		be the re-routed segments.</p>
	</div>

	<div class="content">
		<h1>Using a Default Controller</h1>

		<p>CarbonPHP can be told to load a default controller is no controller is specified in the URI.  You can
		specify the default controller in the configuration file <b>config/routes.php</b>.</p>

		<div class="example">
			$routes['default_controller'] = 'Blog';
		</div>

		<p>This sets the default controller to the one called <b>Blog</b>.  If you load the main <b>index.php</b>
		without any URI segments you should see the 'Hello world' message.</p>
	</div>

	<div class="content">
		<h1>Remapping Method Calls</h1>

		<p>As explained above the second segment of the URI determines which method in the controller is called.
		CarbonPHP allows you to override this through the use of a method called <b>_remap()</b>.</p>

		<div class="example">
			public function _remap()<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;// Code goes here...<br />
			&#125;<br />
		</div>

		<p><i>Note</i>: if you have a controller that contains a method called <b>_remap()</b>, it will always be
		called regardless of what your URI contains.  It overrides the normal behavior in which the URI determines
		which method is called, this allows you to define your own routing rules for methods.</p>

		<p>Typically the second segment of the URI will be passed as a parameter to the <b>_remap()</b> function.</p>

		<div class="example">
			public function _remap($method)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;if ($method == 'some_method')<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->$method();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;else<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->other_method();<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
		</div>
	</div>

	<div class="content">
		<h1>Processing the Output</h1>

		<p>CarbonPHP has a library class that takes care of sending the final rendered output to the web browser.
		However you may wish to post-process the finalised output in some way, and then send it to the web browser
		yourself.  CarbonPHP allows you to do this by adding a method called <b>_output()</b>.</p>

		<p><i>Note</i>: if your controller contains a method called <b>_output()</b>, it will always be called by
		the output class instead of displaying the final data.  THe first parameter of the method will contain the
		final output to be sent to the web browser.</p>

		<div class="example">
			public function _output($output)<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo $output;<br />
			&#125;<br />
		</div>

		<p><i>Note</i>:  the <b>_output()</b> method will receive data in its final state.  Benchmark and memory usage
		data will be rendered, cache files will be written if caching is enabled, and headers will be sent if using
		that feature.  If you are using the <b>_output()</b> method any execution timers and memory usage stats being
		used will not be accurate because they do not take into account the extra processing.</p>
	</div>

	<div class="content">
		<h1>Private Methods</h1>

		<p>In some of your controllers you may wish to have methods that are not accessible by the public.  To make
		a method private you can simple add an underscore to its name and declare it as private.  <i>Note</i>:  you
		cannot simply declare the method as private as this will generate a PHP error.  You must add an underscore.</p>

		<div class="example">
			private function _priv_func()<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Private function!';<br />
			&#125;<br />			
		</div>

		<p>If you tried to access this method via the URL, it would display a 404 page.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/<b>_priv_func</b>/
		</div>
	</div>

	<div class="content">
		<h1>Organising Controllers</h1>

		<p>When creating large web applications you may find it useful to organise controllers into subdirectories.
		You can accomplish this by creating subdirectories in the <b>application/controllers/</b> directory and
		place the controller classes within those subdirectories.  <i>Note</i>: when you use this feature the first
		segment of the URI must specify the directory.</p>

		<div class="example">
			application/controllers/products/tshirts.php
		</div>

		<p>Now when you want to call the above controller you can do the following.</p>

		<div class="example">
			www.your-domain.com/index.php/products/tshirts/short/
		</div>

		<p>Each subdirectory can have its own default controller which is called when the URI only contains the name
		of the subdirectory.  Simple name the default controller as specified in the <b>config/routes.php</b>
		configuration file.  CarbonPHP also allows you to remap your URIs using the URI routing feature.</p>
	</div>

	<div class="content">
		<h1>Class Constructors</h1>

		<p>If you wish to use a constructor in any of your controllers, you must call the parent controllers
		constructor.</p>

		<div class="example">
			parent::__construct()
		</div>

		<p>The reason for this is because the controller constructor will override the parent's constructor.  This
		means that we will have to call it manually.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Shop extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function <b>__construct()</b><br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>parent::__construct()</b><br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;			
		</div>

		<p>Constructors are useful if you need to set any default values, or run a process during the instantiation
		of the class.  Constructors can never return a value, they can however do some of the default work.</p>
	</div>

	<div class="content">
		<h1>Reserved Method Names</h1>

		<p>Since the controller classes are derived from the main controller class you must not name your methods
		identically to ones used by that class.  Otherwise you will be overriding those methods.</p>

		<ul>
			<li>Controller</li>
			<li>Carbon_Base</li>
			<li>c_initialise</li>
			<li>c_scaffolding</li>
		</ul>
	</div>
</body>

</html>
